/*******************************************************************************
 * Copyright 2009, 2010 Lars Grammel 
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 *
 *    http://www.apache.org/licenses/LICENSE-2.0 
 *     
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License.  
 *******************************************************************************/
package org.thechiselgroup.choosel.core.client.importer;

public class ParseException extends Exception {

    private int lineNumber;

    private String unparseableValue;

    public ParseException(String message) {
        this(message, -1);
    }

    public ParseException(String message, int lineNumber) {
        super(message);

        this.lineNumber = lineNumber;
    }

    public ParseException(String message, String unparseableValue,
            int lineNumber) {

        super(message);

        this.unparseableValue = unparseableValue;
        this.lineNumber = lineNumber;
    }

    public ParseException(String message, Throwable cause) {
        this(message, cause, -1);
    }

    public ParseException(String message, Throwable cause, int lineNumber) {
        super(message, cause);

        this.lineNumber = lineNumber;
    }

    public ParseException(String message, Throwable cause,
            String unparseableValue, int lineNumber) {

        super(message, cause);

        this.unparseableValue = unparseableValue;
        this.lineNumber = lineNumber;
    }

    public int getLineNumber() {
        return lineNumber;
    }

    public String getUnparseableValue() {
        return unparseableValue;
    }

}
