/*******************************************************************************
 * Copyright 2009, 2010 Lars Grammel 
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 *
 *    http://www.apache.org/licenses/LICENSE-2.0 
 *     
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License.  
 *******************************************************************************/
package org.thechiselgroup.choosel.core.client.util.url;

import com.google.gwt.user.client.rpc.AsyncCallback;

public interface UrlFetchService {

    /**
     * Similar to JavaScript {@code encodeURIComponent()} function.
     * 
     * @see http://xkr.us/articles/javascript/encode-compare/ for details on why
     *      to prefer {@code encodeURIComponent()} over {@code encode()} and
     *      {@code encodeURI()}.
     */
    String encodeURIComponent(String uriComponent);

    void fetchURL(String url, AsyncCallback<String> callback);

}